library buffer_with_time;

import 'dart:async';
import 'package:flat_map/flat_map.dart';
import 'package:window_with_time/window_with_time.dart';

class BufferWithTime<S, T> extends StreamEventTransformer {

  final Duration _duration;

  const BufferWithTime(this._duration);

  Stream<T> bind(Stream<S> stream) {
    return stream.transform(new WindowWithTime(this._duration, this._duration))
                 .transform(new FlatMap((stream) {
                   return stream.toList().asStream();
                 }));
  }

}